/*Copyright (c) 2003 Sachin Dhir, All Rights Reserved 
Unpublished copyright. This material contains proprietary information 
that shall be used or copied  with written permission of Sachin Dhir. */

/**Minesweeper Applet
 *@version 1.10
 *@author Sachin Dhir
 */
 
 // ROWS and COLUMNS can be changed by changing their parameters
 // Number of BARRIERS can also be changed

import java.util.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Mine extends Applet implements MouseListener {
	
	
	final int ROWS=10;
	final int COLUMNS=10;
	final int BARRIERS=10;
	final int BUTTON_RIGHT=4;
	final int BUTTON_LEFT=16;
	public final static int DeciSecond = 100;
	
	int locX,locY;
	int counter,totalClicks;
	
	javax.swing.Timer timer;
	double time=0;
	
	Panel topPanel;
	JButton start,hundred,ten,one;
	
	Panel bottomPanel;
	JButton cell[][]=new JButton[ROWS][COLUMNS];
	
	Panel downPanel;
	JLabel lbl,timeElapsed;
	
	public void init(){
		
		setLayout(new BorderLayout());
		makeTopPanel();
		
		makeBottomPanel();
		
		downPanel=new Panel();
		lbl=new JLabel("");
		timeElapsed=new JLabel("Time Elapsed = 0.0 seconds");
		downPanel.setLayout(new GridLayout(1,2));
		downPanel.add(lbl);
		downPanel.add(timeElapsed);
		
		add(topPanel,BorderLayout.NORTH);
		add(bottomPanel,BorderLayout.CENTER);
		add(downPanel,BorderLayout.SOUTH);
		
		
		
	}
	
	public void makeTopPanel(){
		
		topPanel=new Panel();
		
		JLabel label=new JLabel("MineSweeper ver1.10 - Sachin Dhir");
		start=new JButton("Start");
		start.setActionCommand("start");
		start.addMouseListener(this);
		start.setBorder(BorderFactory.createRaisedBevelBorder());
		
		hundred=new JButton(new ImageIcon("digits/0.gif"));
		ten=new JButton(new ImageIcon("digits/0.gif"));
		one=new JButton(new ImageIcon("digits/0.gif"));
		
		topPanel.add(label);
		topPanel.add(start);
		topPanel.add(hundred);
		topPanel.add(ten);
		topPanel.add(one);
		
		
	}
	
	
	public void makeBottomPanel(){
		
		counter=0;
		
		totalClicks=0;
		
		bottomPanel=new Panel();
		
		bottomPanel.setLayout(new GridLayout(ROWS,COLUMNS));
		
		initialize();
		
		makeBarriers();

		counter=0;
		
		timer = new javax.swing.Timer(DeciSecond, new ActionListener() {
           	public void actionPerformed(ActionEvent evt) {
                  time++;	
                  if (time % 10==0)
                  	showTime();
                  
              }    
          });
 
		
	}
	
	public void initialize(){
		
		for(int y=0;y<ROWS;y++)
			for(int x=0;x<COLUMNS;x++){
				cell[y][x]=new JButton();
				cell[y][x].setActionCommand("0");
				cell[y][x].addMouseListener(this);
				cell[y][x].setBorder(BorderFactory.createRaisedBevelBorder());
				bottomPanel.add(cell[y][x]);
			}
	}
	
	
	public void showTime(){
			
		int T100,T10,T;
		
		T = (int)time/10;
		
		T100= T/100;
		
		T10=(T-T100*100)/10;
		
		T=T%10;
		
		hundred.setIcon(new ImageIcon("digits/"+T100+".gif"));
		ten.setIcon(new ImageIcon("digits/"+T10+".gif"));
		one.setIcon(new ImageIcon("digits/"+T+".gif"));
		
		timeElapsed.setText("Time elapsed = "+ time/10+" seconds");
		
	}

	
	public void showAll(){
		
		timeElapsed.setText("Time elapsed = "+ time/10+" seconds");
		timer.stop();
		for(int y=0;y<ROWS;y++)
			for(int x=0;x<COLUMNS;x++){
				cell[y][x].removeMouseListener(this);
				if(getCellValue(x,y)==-1)
					if (!((x==locX)&&(y==locY)))
						cell[y][x].setIcon(new ImageIcon("images/bomb.gif"));
			}
				
			
				
		
	}
	
	
	public void makeBarriers(){
		
		int randomX,randomY;

		
		while(counter<BARRIERS){
			randomX=(int)(Math.random()*COLUMNS);
			randomY=(int)(Math.random()*ROWS);
			
			if(getCellValue(randomX,randomY)==0){
				counter++;
				cell[randomY][randomX].setActionCommand("-1");
								
				reinitializeCell(randomX-1,randomY+1);
				reinitializeCell(randomX-1,randomY);
				reinitializeCell(randomX-1,randomY-1);
				reinitializeCell(randomX,randomY-1);
				reinitializeCell(randomX+1,randomY-1);
				reinitializeCell(randomX+1,randomY);
				reinitializeCell(randomX+1,randomY+1);
				reinitializeCell(randomX,randomY+1);
			}
			
		}	
		
	}
	
	
	
	public void reinitializeCell(int x,int y){
		try{
			cell[y][x].setActionCommand(""+ (getCellValue(x,y)+1));
		}catch(Exception e){}
	}
	
	public int getCellValue(int x,int y){
		
		try{
			return Integer.parseInt(cell[y][x].getActionCommand());
		}
		catch(Exception e){}
		
		return 0;
		
	}
	
	
	public void gameOver(){
		lbl.setText("Game over!!!");
		cell[locY][locX].setIcon(new ImageIcon("images/cross.jpg"));
		showAll();
		 
	}
	
	public void openAssePasse(int x,int y){
		

		try{
			if (getCellValue(x,y)!=-10){//all cell which have been checked will be -10			
				cell[y][x].removeMouseListener(this);
						totalClicks++;	
				cell[y][x].setBorder(BorderFactory.createLoweredBevelBorder());
				if (getCellValue(x,y)>0){
					cell[y][x].setIcon(new ImageIcon("images/"+getCellValue(x,y)+".gif"));
					cell[y][x].setActionCommand("-10");
					return;
				}
				cell[y][x].setActionCommand("-10");
			}else{return;}
		}catch(Exception e){return;}
			
		openAssePasse(x-1,y+1);
		openAssePasse(x-1,y);
		openAssePasse(x-1,y-1);
		openAssePasse(x,y-1);
		openAssePasse(x+1,y-1);
		openAssePasse(x+1,y);
		openAssePasse(x+1,y+1);
		openAssePasse(x,y+1);
			
		
		
	}
	
	public void mousePressed(MouseEvent me){
		
		locX=((JButton)me.getSource()).getX()/((JButton)me.getSource()).getWidth();
		locY=((JButton)me.getSource()).getY()/((JButton)me.getSource()).getHeight();

 		
 		if (((JButton)me.getSource()).getActionCommand().equals("start")){
 			timer.start();
 			((JButton)me.getSource()).removeMouseListener(this);
 			return;	
 			
 		}
 		
 		if(totalClicks==0){
 			timer.start();
 			start.removeMouseListener(this);	
 		}
		
		
		if (me.getModifiers()==BUTTON_RIGHT){
			if ((cell[locY][locX].getIcon()==null)||
				(cell[locY][locX]).getIcon().toString()=="images/55.gif")
			{
 				if (counter<BARRIERS){
 					cell[locY][locX].setIcon(new ImageIcon("images/flag.gif"));
					counter++;
				//	System.out.println("Total = "+totalClicks+"  "+(ROWS*COLUMNS-BARRIERS));
				}
			}else{
				counter--;
				cell[locY][locX].setIcon(new ImageIcon("images/55.gif"));
			}
			
			if (totalClicks==ROWS*COLUMNS-BARRIERS){
 				System.out.println("You have won!!!");
 				lbl.setText("You have won!!!");
 				showAll();	
			}
			return;
		}
	

		
		if (getCellValue(locX,locY)==-1)
			gameOver();
		else{
				if (getCellValue(locX,locY)==0)
					openAssePasse(locX,locY);
				else{
					totalClicks++;
					cell[locY][locX].removeMouseListener(this); 
					cell[locY][locX].setIcon(new ImageIcon("images/"+getCellValue(locX,locY)+".gif"));
					cell[locY][locX].setBorder(BorderFactory.createLoweredBevelBorder());
					cell[locY][locX].setActionCommand("-10");
					if (totalClicks==ROWS*COLUMNS-BARRIERS){
 						System.out.println("You have won!!!");
 						lbl.setText("You have won!!!");
 						showAll();	
					}
				}
				

		}	
		
		
	}
	
	public void  mouseClicked(MouseEvent me){}
	
	public void  mouseReleased(MouseEvent me){}
	
	public void  mouseEntered(MouseEvent me){}
	
	public void  mouseExited(MouseEvent me){}
	

}
